diff -u -r linux.clean/drivers/scsi/st.c linux.new2/drivers/scsi/st.c
--- linux.clean/drivers/scsi/st.c	Wed Jul 28 18:24:34 1999
+++ linux.new2/drivers/scsi/st.c	Wed Jul 28 19:22:40 1999
@@ -265,14 +265,25 @@
 st_do_scsi(Scsi_Cmnd *SCpnt, Scsi_Tape *STp, unsigned char *cmd, int bytes,
 	   int timeout, int retries, int do_wait)
 {
+#ifndef CONFIG_SCSI_NEW_QUEUES
   unsigned long flags;
+#endif
   unsigned char *bp;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
   spin_lock_irqsave(&io_request_lock, flags);
+#endif
   if (SCpnt == NULL)
-    if ((SCpnt = scsi_allocate_device(NULL, STp->device, 1)) == NULL) {
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    if ((SCpnt = scsi_allocate_device(STp->device, 1)) == NULL) 
+#else
+    if ((SCpnt = scsi_allocate_device(NULL, STp->device, 1)) == NULL) 
+#endif
+    {
       printk(KERN_ERR "st%d: Can't get SCSI request.\n", TAPE_NR(STp->devt));
+#ifndef CONFIG_SCSI_NEW_QUEUES
       spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
       return NULL;
     }
 
@@ -294,7 +305,9 @@
 
   scsi_do_cmd(SCpnt, (void *)cmd, bp, bytes,
 	      st_sleep_done, timeout, retries);
+#ifndef CONFIG_SCSI_NEW_QUEUES
   spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 
   if (do_wait) {
       down(SCpnt->request.sem);
diff -u -r linux.clean/include/linux/blk.h linux.new2/include/linux/blk.h
--- linux.clean/include/linux/blk.h	Mon Sep  6 04:42:10 1999
+++ linux.new2/include/linux/blk.h	Sun Sep  5 15:07:04 1999
@@ -144,9 +144,11 @@
 #elif (SCSI_DISK_MAJOR(MAJOR_NR))
 
 #define DEVICE_NAME "scsidisk"
+#ifndef CONFIG_SCSI_NEW_QUEUES
 #define DEVICE_INTR do_sd  
-#define TIMEOUT_VALUE (2*HZ)
 #define DEVICE_REQUEST do_sd_request
+#endif
+#define TIMEOUT_VALUE (2*HZ)
 #define DEVICE_NR(device) (((MAJOR(device) & SD_MAJOR_MASK) << (8 - 4)) + (MINOR(device) >> 4))
 #define DEVICE_ON(device)
 #define DEVICE_OFF(device)
@@ -171,8 +173,10 @@
 #elif (MAJOR_NR == SCSI_CDROM_MAJOR)
 
 #define DEVICE_NAME "CD-ROM"
+#ifndef CONFIG_SCSI_NEW_QUEUES
 #define DEVICE_INTR do_sr
 #define DEVICE_REQUEST do_sr_request
+#endif
 #define DEVICE_NR(device) (MINOR(device))
 #define DEVICE_ON(device)
 #define DEVICE_OFF(device)
@@ -383,7 +387,7 @@
 #if !defined(IDE_DRIVER)
 
 #ifndef CURRENT
-#define CURRENT (blk_dev[MAJOR_NR].current_request)
+#define CURRENT (blk_dev[MAJOR_NR].request_queue.current_request)
 #endif
 
 #ifndef DEVICE_NAME
@@ -417,7 +421,9 @@
 
 #endif /* DEVICE_TIMEOUT */
 
-static void (DEVICE_REQUEST)(void);
+#ifdef DEVICE_REQUEST
+static void (DEVICE_REQUEST)(request_queue_t *);
+#endif 
   
 #ifdef DEVICE_INTR
 #define CLEAR_INTR SET_INTR(NULL)
diff -u -r linux.clean/include/linux/blkdev.h linux.new2/include/linux/blkdev.h
--- linux.clean/include/linux/blkdev.h	Mon Sep  6 04:39:43 1999
+++ linux.new2/include/linux/blkdev.h	Sun Sep  5 15:06:56 1999
@@ -26,6 +26,8 @@
 	unsigned long sector;
 	unsigned long nr_sectors;
 	unsigned long current_nr_sectors;
+	unsigned long nr_sg_segments; /* # scatter-gather segments */
+        void * special;
 	char * buffer;
 	struct semaphore * sem;
 	struct buffer_head * bh;
@@ -33,19 +35,57 @@
 	struct request * next;
 };
 
-typedef void (request_fn_proc) (void);
-typedef struct request ** (queue_proc) (kdev_t dev);
+typedef struct request_queue request_queue_t;
+typedef int (merge_request_fn) (request_queue_t *, 
+				struct request  * req,
+				struct buffer_head *);
+typedef int (merge_requests_fn) (request_queue_t *, 
+				 struct request  * req,
+				 struct request  * req2);
+typedef void (request_fn_proc) (request_queue_t *);
+typedef request_queue_t * (queue_proc) (kdev_t dev);
+
+struct request_queue
+{
+	struct request		* current_request;
+	request_fn_proc		* request_fn;
+	merge_request_fn	* merge_fn;
+	merge_requests_fn	* merge_requests_fn;
+	/*
+	 * The queue owner gets to use this for whatever they like.
+	 * ll_rw_blk doesn't touch it.
+	 */
+	void                    * queuedata;
+
+	/*
+	 * This is used to remove the plug when tq_disk runs.
+	 */
+	struct tq_struct          plug_tq;
+	/*
+	 * Boolean that indicates whether this queue is plugged or not.
+	 */
+	char			  plugged;
+
+	/*
+	 * Boolean that indicates whether current_request is active or
+	 * not.
+	 */
+	char			  head_active;
+
+	/*
+	 * Boolean that indicates whether we should use plugging on
+	 * this queue or not.
+	 */
+	char			  use_plug; 
+};
 
 struct blk_dev_struct {
-	request_fn_proc		*request_fn;
 	/*
 	 * queue_proc has to be atomic
 	 */
+	request_queue_t		request_queue;
 	queue_proc		*queue;
 	void			*data;
-	struct request		*current_request;
-	struct request   plug;
-	struct tq_struct plug_tq;
 };
 
 struct sec_size {
@@ -53,12 +93,28 @@
 	unsigned block_size_bits;
 };
 
+/*
+ * Used to indicate the default queue for drivers that don't bother
+ * to implement multiple queues.  We have this access macro here
+ * so as to eliminate the need for each and every block device
+ * driver to know about the internal structure of blk_dev[].
+ */
+#define BLK_DEFAULT_QUEUE(_MAJOR)  &blk_dev[_MAJOR].request_queue
+
 extern struct sec_size * blk_sec[MAX_BLKDEV];
 extern struct blk_dev_struct blk_dev[MAX_BLKDEV];
 extern wait_queue_head_t wait_for_request;
 extern void resetup_one_dev(struct gendisk *dev, int drive);
 extern void unplug_device(void * data);
 extern void make_request(int major,int rw, struct buffer_head * bh);
+
+/*
+ * Access functions for manipulating queue properties
+ */
+extern void blk_init_queue(request_queue_t *, request_fn_proc *);
+extern void blk_cleanup_queue(request_queue_t *);
+extern void blk_queue_headactive(request_queue_t *, int);
+extern void blk_queue_pluggable(request_queue_t *, int);
 
 /* md needs this function to remap requests */
 extern int md_map (int minor, kdev_t *rdev, unsigned long *rsector, unsigned long size);
diff -u -r linux.clean/include/linux/fs.h linux.new2/include/linux/fs.h
--- linux.clean/include/linux/fs.h	Mon Sep  6 04:39:32 1999
+++ linux.new2/include/linux/fs.h	Sun Sep  5 14:25:33 1999
@@ -62,6 +62,7 @@
 #define WRITE 1
 #define READA 2		/* read-ahead  - don't block if no resources */
 #define WRITEA 3	/* write-ahead - don't block if no resources */
+#define SPECIAL 4	/* For non-blockdevice requests in request queue */
 
 #ifndef NULL
 #define NULL ((void *) 0)
diff -u -r linux.clean/include/linux/ide.h linux.new2/include/linux/ide.h
--- linux.clean/include/linux/ide.h	Mon Sep  6 04:42:26 1999
+++ linux.new2/include/linux/ide.h	Sun Sep  5 15:07:48 1999
@@ -234,7 +234,7 @@
 	} special_t;
 
 typedef struct ide_drive_s {
-	struct request		*queue;	/* request queue */
+	request_queue_t		 queue;	/* request queue */
 	struct ide_drive_s 	*next;	/* circular list of hwgroup drives */
 	unsigned long sleep;		/* sleep until this time */
 	unsigned long service_start;	/* time we started last request */
@@ -723,7 +723,7 @@
 /*
  * ide_get_queue() returns the queue which corresponds to a given device.
  */
-struct request **ide_get_queue (kdev_t dev);
+request_queue_t *ide_get_queue (kdev_t dev);
 
 /*
  * CompactFlash cards and their brethern pretend to be removable hard disks,
@@ -736,27 +736,27 @@
 void ide_timer_expiry (unsigned long data);
 void ide_intr (int irq, void *dev_id, struct pt_regs *regs);
 void ide_geninit (struct gendisk *gd);
-void do_ide0_request (void);
+void do_ide0_request (request_queue_t * q);
 #if MAX_HWIFS > 1
-void do_ide1_request (void);
+void do_ide1_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 2
-void do_ide2_request (void);
+void do_ide2_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 3
-void do_ide3_request (void);
+void do_ide3_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 4
-void do_ide4_request (void);
+void do_ide4_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 5
-void do_ide5_request (void);
+void do_ide5_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 6
-void do_ide6_request (void);
+void do_ide6_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 7
-void do_ide7_request (void);
+void do_ide7_request (request_queue_t * q);
 #endif
 void ide_init_subdrivers (void);
 
